Package: geigen
Version: 2.3
Title: Calculate Generalized Eigenvalues, the Generalized Schur
        Decomposition and the Generalized Singular Value Decomposition
        of a Matrix Pair with Lapack
Date: 2019-05-29
Depends: R (>= 3.5.0)
Authors@R: c(person("Berend","Hasselman",role=c("cre","aut"),email="bhh@xs4all.nl"),
            person("Lapack authors", role=c("aut","cph")))
Description: Functions to compute generalized eigenvalues and eigenvectors,
             the generalized Schur decomposition and
             the generalized Singular Value Decomposition of a matrix pair,
             using Lapack routines.
License: GPL (>= 2)
Copyright: see inst/COPYRIGHTS for the files in src/.
NeedsCompilation: yes
Packaged: 2019-05-30 06:10:31 UTC; berendhasselman
Author: Berend Hasselman [cre, aut],
  Lapack authors [aut, cph]
Maintainer: Berend Hasselman <bhh@xs4all.nl>
Repository: CRAN
Date/Publication: 2019-05-30 09:30:03 UTC
Built: R 3.6.1; x86_64-w64-mingw32; 2019-08-20 16:27:02 UTC; windows
Archs: x64

# from Octave's eigen test
library(geigen)
source("testgv.R")

A <- matrix(c(1, 2, -1, 1),nrow=2, byrow=TRUE)
B <- matrix(c(3, 3,  1, 2),nrow=2, byrow=TRUE)

z <- geigen(A,B)
testgv(A,B,z)

A <- matrix(c(1, 2,  2, 1),nrow=2, byrow=TRUE)
B <- matrix(c(3,-2, -2, 3),nrow=2, byrow=TRUE)

z <- geigen(A,B)
testgv(A,B,z)

z <- geigen(A,B, symmetric=TRUE)
testgv(A,B,z)

# Complex
A <- matrix(c(1+3i, 2+1i, 2-1i, 1+3i),nrow=2, byrow=TRUE)
B <- matrix(c(5+9i, 2+1i, 2-1i, 5+9i),nrow=2, byrow=TRUE)

z <- geigen(A,B)
testgv(A,B,z)

# Hermitian 
A <- matrix(c(3, 2+1i, 2-1i, 5),nrow=2, byrow=TRUE)
B <- matrix(c(5, 2+1i, 2-1i, 5),nrow=2, byrow=TRUE)

z <- geigen(A,B)
testgv(A,B,z)

z <- geigen(A,B, symmetric=TRUE)
testgv(A,B,z)
 
A <- matrix(c(1+3i, 2+3i, 3-8i, 8+3i),nrow=2, byrow=TRUE)
B <- matrix(c(8+1i, 3+1i, 4-9i, 3+1i ),nrow=2, byrow=TRUE)

z <- geigen(A,B)
testgv(A,B,z)

A <- matrix(c(1, 2, 3, 8),nrow=2, byrow=TRUE)
B <- matrix(c(8, 3, 4, 3),nrow=2, byrow=TRUE)

z <- geigen(A,B)
testgv(A,B,z)

library("geigen")
source("testqz.R")

set.seed(11)

n <- 5
A <- matrix(runif(n*n),nrow=n)
B <- matrix(runif(n*n),nrow=n)

B[5,] <- (B[4,]+B[3,])/2

# Test interface to dgges (QZ method)

z <- gqz(A, B,"-")
testqz(A,B,z)
gev <- gevalues(z)
all(which(ifelse(is.finite(gev),Re(gev)<0,FALSE)) == seq_len(z$sdim))

z <- gqz(A, B,"+")
testqz(A,B,z)
gev <- gevalues(z)
all(which(ifelse(is.finite(gev),Re(gev)>0,FALSE)) == seq_len(z$sdim))

z <- gqz(A, B,"S")
testqz(A,B,z)
gev <- gevalues(z)
all(which(ifelse(is.finite(gev),abs(gev)<1,FALSE)) == seq_len(z$sdim))

z <- gqz(A, B,"B")
testqz(A,B,z)
gev <- gevalues(z)
all(which(ifelse(is.finite(gev),abs(gev)>1,FALSE)) == seq_len(z$sdim))

z <- gqz(A, B,"R")
testqz(A,B,z)
gev <- gevalues(z)
all(which(ifelse(is.finite(gev),abs(Im(gev)) <= 100*.Machine$double.eps,FALSE)) == seq_len(z$sdim))

library("geigen")
source("testgsvd.R")

# Example from NAG F08VAF

A <- matrix(c(1,2,3,3,2,1,4,5,6,7,8,8), nrow=4, ncol=3, byrow=TRUE)

B <- matrix(c(-2,-3,3,4,6,5), nrow=2, ncol=3, byrow=TRUE)

A
B

z <- gsvd(A,B)
testgsvd(z,A,B)

# B modified

B <- matrix(1:18,byrow=TRUE, ncol=3)
B

z <- gsvd(A,B)
testgsvd(z,A,B)

library(geigen)
source("testgv.R")

# Data from R-help mailinglist: Solve an ordinary or generalized eigenvalue problem in R?
# started on 19-04-2012

A <- matrix(c(1457.738, 1053.181, 1256.953,
              1053.181, 1213.728, 1302.838,
              1256.953, 1302.838, 1428.269), nrow=3, byrow=TRUE)

B <- matrix(c(4806.033, 1767.480, 2622.744,
              1767.480, 3353.603, 3259.680,
              2622.744, 3259.680, 3476.790), nrow=3, byrow=TRUE)

z1 <- geigen(A, B, symmetric=FALSE, only.values=TRUE)
z2 <- geigen(A, B, symmetric=FALSE, only.values=FALSE )
all.equal(z1$values, z2$values)
testgv(A,B,z2)  

# geigen(A, B)
z1 <- geigen(A, B, only.values=TRUE)
z2 <- geigen(A, B, only.values=FALSE)
all.equal(z1$values, z2$values)
testgv(A,B,z2)  

A.c <- A + 1i
B.c <- B + 1i
isSymmetric(A.c)
isSymmetric(B.c)

z1 <- geigen(A.c, B.c, only.values=TRUE)
z2 <- geigen(A.c, B.c, only.values=FALSE)
all.equal(z1$values, z2$values)
testgv(A.c,B.c,z2)

A[upper.tri(A)] <- A[upper.tri(A)] + 1i   
A[lower.tri(A)] <- Conj(t(A[upper.tri(A)]))

B[upper.tri(B)] <- B[upper.tri(B)] + 1i
B[lower.tri(B)] <- Conj(t(B[upper.tri(B)])) 

isSymmetric(A)
isSymmetric(B) 

z1 <- geigen(A, B, only.values=TRUE)
z2 <- geigen(A, B, only.values=FALSE)
all.equal(z1$values, z2$values)
testgv(A,B,z2)  

testqz <- function(A,B,z) {
    VL <- z$Q
    VR <- z$Z

    tol <- 100 * sqrt(.Machine$double.eps)
    ret <- logical(4)

    if( is.complex(A) || is.complex(B) ) {
        tmp <- A - VL %*% z$S %*% Conj(t(VR))
        ret[1] <- all(abs(tmp)<=tol)
        tmp <- B - VL %*% z$T %*% Conj(t(VR))    
        ret[2] <- all(abs(tmp)<=tol)
        
        ret[3] <- all(abs(z$Q %*% Conj(t(z$Q))-diag(1.0,nrow(z$Q),ncol(z$Q)))<=tol)
        ret[4] <- all(abs(z$Z %*% Conj(t(z$Z))-diag(1.0,nrow(z$Z),ncol(z$Z)))<=tol)

    }
    else {
        tmp <- A - VL %*% z$S %*% t(VR)
        ret[1] <- all(abs(tmp)<=tol)
        tmp <- B - VL %*% z$T %*% t(VR)
        ret[2] <- all(abs(tmp)<=tol)
        ret[3] <- all(abs(z$Q %*% t(z$Q)-diag(1.0,nrow(z$Q),ncol(z$Q)))<=tol)
        ret[4] <- all(abs(z$Z %*% t(z$Z)-diag(1.0,nrow(z$Z),ncol(z$Z)))<=tol)
    }

    ret
}

testgv <- function(A,B,z) {
    V <- z$vectors         
    if( is.null(z$alpha) ) {
        ret <- A %*% V - B %*% V %*% diag(z$values)
    } else {
        ret <- A %*% V %*% diag(z$beta) - B %*% V %*% diag(z$alpha)
    }
    tol <- 100 * sqrt(.Machine$double.eps)
    all(abs(ret)<=tol)
}

library("geigen")
source("testgsvd.R")

# double
set.seed(11)
A <- matrix(round(runif(18),2), nrow=3, byrow=TRUE)
B <- matrix(round(runif(30),2), ncol=6, byrow=TRUE)
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(18),2), nrow=3, byrow=TRUE)
B <- matrix(round(runif(24),2), ncol=6, byrow=TRUE)
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(36),2), ncol=6, byrow=TRUE)
B <- matrix(round(runif(36),2), ncol=6, byrow=TRUE)
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(36),2), ncol=6, byrow=TRUE)
B <- matrix(round(runif(24),2), ncol=6, byrow=TRUE)
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(12),2), nrow=2, byrow=TRUE)
B <- matrix(round(runif(24),2), ncol=6, byrow=TRUE)
z <- gsvd(A,B)
testgsvd(z,A,B)

library("geigen")
source("testgv.R")

# tol <-  0 triggers buglet in complex QR
tol <- .Machine$double.eps
set.seed(11)

n <- 5
A.save <- matrix(runif(n*n),nrow=n)
B.save <- matrix(runif(n*n),nrow=n)
A.save <- (A.save+t(A.save))/2
B.save <- (B.save+t(B.save))/2
diag(B.save) <- diag(B.save) + 1

A <- A.save
B <- B.save
B
isSymmetric(A)
isSymmetric(B)
z <- geigen(A,B)
testgv(A,B,z)

A <- A.save+0i
B <- B.save+0i
z <- geigen(A,B)
testgv(A,B,z)

A <- A.save
B <- B.save
z <- geigen(A,B)
testgv(A,B,z)

A <- A.save+0i
B <- B.save+0i
z <- geigen(A,B)
testgv(A,B,z)

library(geigen)
source("testgsvd.R")

# from NAG documentation F08VNF
# complex
A <- matrix( c( .96-.81i , -.03+.96i , -.91+2.06i, -.05+.41i,
               -.98+1.98i, -1.20+.19i, -.66+.42i , -.81+.56i,
                .62-.46i ,  1.01+.02i,  .63-.17i ,-1.11+.6i,
                .37+.38i ,  .19-.54i ,-.98-.36i  ,  .22-.2i,
                .83+.51i ,  .2+.01i  ,-.17-.46i  , 1.47+1.59i,
               1.08-.28i ,  .2-.12i  ,-.07+1.23i ,  .26+.26i),
               nrow=6, ncol=4, byrow=TRUE)

B <- matrix(c(1,0,-1,0,0,1,0,-1), ncol=4, byrow=TRUE)

z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(18),2), nrow=3, byrow=TRUE)
B <- matrix(round(runif(30),2), ncol=6, byrow=TRUE)
A <- A+0i
B <- B+0i
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(18),2), nrow=3, byrow=TRUE)
B <- matrix(round(runif(24),2), ncol=6, byrow=TRUE)
A <- A+0i
B <- B+0i
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(36),2), ncol=6, byrow=TRUE)
B <- matrix(round(runif(36),2), ncol=6, byrow=TRUE)
A <- A+0i
B <- B+0i
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(36),2), ncol=6, byrow=TRUE)
B <- matrix(round(runif(24),2), ncol=6, byrow=TRUE)
A <- A+0i
B <- B+0i
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
A <- matrix(round(runif(12),2), nrow=2, byrow=TRUE)
B <- matrix(round(runif(24),2), ncol=6, byrow=TRUE)
A <- A+0i
B <- B+0i
z <- gsvd(A,B)
testgsvd(z,A,B)

set.seed(11)
NrowA <- 25
NrowB <- 5
Ncol  <- 6
A <- matrix(round(runif(NrowA*Ncol),2), ncol=Ncol, byrow=TRUE)
B <- matrix(round(runif(NrowB*Ncol),2), ncol=Ncol, byrow=TRUE)
A <- A+matrix(round(runif(NrowA*Ncol),2)*1i, ncol=Ncol, byrow=TRUE)
B <- B+matrix(round(runif(NrowB*Ncol),2)*1i, ncol=Ncol, byrow=TRUE)
z <- gsvd(A,B)
testgsvd(z,A,B)

testgsvd <- function(z,A,B) {
    tol <- 100*.Machine$double.eps

    if( inherits(z,"xzgsvd") ) {
        chkA <- Conj(t(z$U)) %*% A %*% z$Q
        chkB <- Conj(t(z$V)) %*% B %*% z$Q
    } else if( inherits(z,"xdgsvd") ) {
        chkA <- t(z$U) %*% A %*% z$Q
        chkB <- t(z$V) %*% B %*% z$Q
    } else stop("argument z not result of gsvd")

    oR <- gsvd.oR(z)
    D1 <- gsvd.D1(z)
    D2 <- gsvd.D2(z)

#    print(chkA-D1 %*% oR)
#    print(chkB-D2 %*% oR)

    ret <- logical(4)
#    print(abs(chkA-D1 %*% oR))
#    print(abs(chkB-D2 %*% oR))
    ret[1] <- all(abs(chkA-D1 %*% oR) <= tol)
    ret[2] <- all(abs(chkB-D2 %*% oR) <= tol)
    ret[3] <- all(abs(t(D1) %*% D1 + t(D2) %*% D2 - diag(1,nrow=z$k+z$l)) <= tol)

#   check alpha^2 + beta^2 == 1
    salpha <- 0
    sbeta  <- 0
    m <- z$m
    k <- z$k
    l <- z$l
    if(m-k-l >= 0 ) {
        if(l > 0) {
            salpha <- z$alpha[(k+1):(k+l)]^2
            sbeta  <- z$beta[(k+1):(k+l)]^2
        }
    } else {
        if(m > k) {
            salpha <- z$alpha[(k+1):m]^2
            sbeta  <- z$beta[(k+1):m]^2
        }
    }
#    print(salpha)
#    print(sbeta)
#    print(salpha+sbeta)
    ret[4] <- all(salpha+sbeta-1<=tol)

    ret
}

library("geigen")
source("testgv.R")

# tol <-  0 triggers buglet in complex QR
tol <- .Machine$double.eps
set.seed(11)

n <- 5
A.save <- matrix(runif(n*n),nrow=n)
B.save <- matrix(runif(n*n),nrow=n)

A <- A.save
B <- B.save
B[5,] <- (B[4,]+B[3,])/2 + tol
z <- geigen(A,B)
testgv(A,B,z)

A <- A.save+0i
B <- B.save+0i
B[5,] <- (B[4,]+B[3,])/2 + tol
z <- geigen(A,B)
testgv(A,B,z)

A <- A.save
B <- B.save
B[1,] <- (B[2,]+B[3,])/2 + tol
z <- geigen(A,B)
testgv(A,B,z)

A <- A.save+0i
B <- B.save+0i
B[1,] <- (B[2,]+B[3,])/2 + tol
z <- geigen(A,B)
testgv(A,B,z)

library("geigen")
source("testgsvd.R")

# Example from Matlab
# http://nl.mathworks.com/help/matlab/ref/gsvd.html
# also see http://www.netlib.org/lapack/lug/node36.html

A <- matrix(1:15, nrow=5,ncol=3)

B <- matrix(c(8,1,6,
              3,5,7,
              4,9,2), nrow=3)

A
B

z <- gsvd(A,B)
testgsvd(z,A,B)
